#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include "field.h"

void initField(grid *f) {
  grid g = *f;
  float a,x,y,z;
  int i,j,k,c,n;
  n = 0;
  /*for(i=0; i<g.vSize; i++)
    g.v[n++] = 0;*/
  for(k=0; k<g.d; k++) {
    z = k/(float)g.d-0.5;
    for(j=0; j<g.h; j++) {
      y = j/(float)g.h-0.5;
      for(i=0; i<g.w; i++) {
        x = i/(float)g.w-0.5;
        a = sqrt(x*x+z*z)-0.25;
        if(a*a+y*y<0.01) {
          for(c=0;c<g.dim;c++)
            g.v[n++] = rand()/(float)RAND_MAX;
        }
        else {
          for(c=0;c<g.dim;c++)
            g.v[n++] = 0;
        }
      }
    }
  }
}

void stepField(grid *f) {
  grid g = *f;
  int x,y,z,c, i=0, line=g.dim*g.w, plane=g.dim*g.w*g.h, n;
  float sum; // and jetsom
  for(z=0; z<g.d; z++) {
    for(y=0; y<g.h; y++) {
      for(x=0; x<g.w; x++) {
        for(c=0; c<g.dim; c++) {
          sum = g.v[i]; n = 1;
          if(x>0) { sum+=g.v[i-g.dim]; n++; }
          if(x<g.w-1) { sum+=g.v[i+g.dim]; n++; }
          if(y>0) { sum+=g.v[i-line]; n++; }
          if(y<g.h-1) { sum+=g.v[i+line]; n++; }
          if(z>0) { sum+=g.v[i-plane]; n++; }
          if(z<g.d-1) { sum+=g.v[i+plane]; n++; }
          g.v[i] = sum/n;// poop
          i++;
        }
      }
    }
  }
}

void clickField(grid *f, double *a0, double *a1) {
  grid g = *f;
  // use midpoint of segment:
  float x0 = a0[0]*0.5 + a1[0]*0.5,
    y0 = a0[1]*0.5 + a1[1]*0.5,
    z0 = a0[2]*0.5 + a1[2]*0.5,
    a, x,y,z;
  int i,j,k,c,n;
  n = 0;
  for(k=0; k<g.d; k++) {
    z = k/(float)g.d-z0;
    for(j=0; j<g.h; j++) {
      y = j/(float)g.h-y0;
      for(i=0; i<g.w; i++) {
        x = i/(float)g.w-x0;
        a = sqrt(x*x+z*z)-0.2;
        if(a*a+y*y<0.003) {
          for(c=0;c<g.dim;c++)
            g.v[n++] = rand()/(float)RAND_MAX;
        }
        else
          n+=g.dim;
      }
    }
  }
}
